#ifndef PHILOSOPHER_HH__
#define PHILOSOPHER_HH__

#include "Thread.hh"
#include "Chopstick.hh"

class Philosopher: public Thread {
	int id_;
	Chopstick* left_;
	Chopstick* right_;
	bool stop_called_;
	Mutex stop_mutex_;

	bool is_stopped();

	int random_sleep();

	void thinking();
	void eating();
public:

	static const int SLEEP_MAX=10;

	Philosopher(int id, Chopstick* left, Chopstick* right);
	
	void run();
	void stop();
};

#endif
