#include "Chopstick.hh"
#include "Philosopher.hh"

#include <iostream>
#include <ctime>
#include <vector>
using namespace std;

static const int PHILOSOPHERS=5;

int left_stick(int philosopher) {
	return philosopher;
}
int right_stick(int philosopher) {
	return (philosopher+1)%PHILOSOPHERS;
}

int main() {
	vector<Chopstick*> chopsticks;
	vector<Philosopher*> philosophers;

	for(int i=0;i<PHILOSOPHERS;i++) {
		chopsticks.push_back(new Chopstick(i));		
	}
	
	for(int i=0;i<PHILOSOPHERS;i++) {
		philosophers.push_back(new Philosopher(i,chopsticks[left_stick(i)],chopsticks[right_stick(i)]));
	}

	for(int i=0;i<PHILOSOPHERS;i++) {
		philosophers[i]->start();
	}

	sleep(30);
	
	for(int i=0;i<PHILOSOPHERS;i++) {
		cerr << "stopping philosopher(" << i << ")..." << endl;
		philosophers[i]->stop();
	}
	for(int i=0;i<PHILOSOPHERS;i++) {
		cerr << "joining philosopher(" << i << ")..." << endl;
		philosophers[i]->join();
	}

	for(int i=0;i<PHILOSOPHERS;i++) {
		cerr << "deleting philosopher(" << i << ")..." << endl;
		delete philosophers[i];
	}
	for(int i=0;i<PHILOSOPHERS;i++) {
		cerr << "deleting chopstick(" << i << ")..." << endl;
		delete chopsticks[i];
	}

	return 0;
};



